﻿Imports System.Collections.Specialized
Imports System.ComponentModel.DataAnnotations
Imports System.Web.DynamicData
Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace CSSAdmin
	Partial Public Class ForeignKeyField
		Inherits DynamicData.FieldTemplateUserControl
		Private _allowNavigation As Boolean = True

        Private _NavigateUrl As String
		Public Property NavigateUrl() As String
			Get
                Return _NavigateUrl
			End Get
			Set(ByVal value As String)
                _NavigateUrl = value
			End Set
		End Property

		Public Property AllowNavigation() As Boolean
			Get
				Return _allowNavigation
			End Get
			Set(ByVal value As Boolean)
				_allowNavigation = value
			End Set
		End Property

		Protected Function GetDisplayString() As String
            Dim value = FieldValue

			If value Is Nothing Then
				Return FormatFieldValue(ForeignKeyColumn.GetForeignKeyString(Row))
			Else
				Return FormatFieldValue(ForeignKeyColumn.ParentTable.GetDisplayString(value))
			End If
		End Function

		Protected Function GetNavigateUrl() As String
			If Not AllowNavigation Then
				Return Nothing
			End If

			If String.IsNullOrEmpty(NavigateUrl) Then
				Return ForeignKeyPath
			Else
				Return BuildForeignKeyPath(NavigateUrl)
			End If
		End Function

		Public Overrides ReadOnly Property DataControl() As Control
			Get
				Return HyperLink1
			End Get
		End Property

	End Class
End Namespace
