﻿Imports System.Collections
Imports System.Collections.Specialized
Imports System.ComponentModel.DataAnnotations
Imports System.Linq.Expressions
Imports System.Web.DynamicData
Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace CSSAdmin
	Partial Public Class EnumerationFilter
		Inherits DynamicData.QueryableFilterUserControl
		Private Const NullValueString As String = "[null]"
		Public Overrides ReadOnly Property FilterControl() As Control
			Get
				Return DropDownList1
			End Get
		End Property

		Public Sub Page_Init(ByVal sender As Object, ByVal e As EventArgs)
			If Not Page.IsPostBack Then
				If Not Column.IsRequired Then
					DropDownList1.Items.Add(New ListItem("[Not Set]", NullValueString))
				End If
				PopulateListControl(DropDownList1)
				' Set the initial value if there is one
                Dim initialValue = DefaultValue
				If Not String.IsNullOrEmpty(initialValue) Then
					DropDownList1.SelectedValue = initialValue
				End If
			End If
		End Sub

		Public Overrides Function GetQueryable(ByVal source As IQueryable) As IQueryable
            Dim selectedValue = DropDownList1.SelectedValue
			If String.IsNullOrEmpty(selectedValue) Then
				Return source
			End If

			Dim value As Object = selectedValue
			If selectedValue = NullValueString Then
				value = Nothing
			End If
			If DefaultValues IsNot Nothing Then
				DefaultValues(Column.Name) = value
			End If
			Return ApplyEqualityFilter(source, Column.Name, value)
		End Function

		Protected Sub DropDownList1_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
			OnFilterChanged()
		End Sub

	End Class
End Namespace
