﻿Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports System.ServiceModel.DomainServices.EntityFramework
Imports System.ServiceModel.DomainServices.Hosting
Imports System.ServiceModel.DomainServices.Server
Imports CSSModel

Namespace CSSCustomerEdit.Web.Services


	' Implements application logic using the CSSModelContainer context.
	' TODO: Add your application logic to these methods or in additional methods.
	' TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
	' Also consider adding roles to restrict access as appropriate.
	' [RequiresAuthentication]
	<EnableClientAccess()>
	Public Class CSSDomainService
        Inherits LinqToEntitiesDomainService(Of CSSModelContainer)

        Private myCompany As Integer = 1 ' TODO: set myCompany during authentication
		Public Function GetMyCompany() As Company
            Return Me.ObjectContext.Companies.Single(Function(c) c.Id.Equals(myCompany))
		End Function

		Public Sub UpdateCompany(ByVal currentCompany As Company)
			' TODO: ensure user only edits authorized companies
            Me.ObjectContext.Companies.AttachAsModified(currentCompany,
                                                        Me.ChangeSet.GetOriginal(currentCompany))
		End Sub

		Public Function GetMyStories() As IQueryable(Of Story)
			Return Me.ObjectContext.Stories.Where(Function(s) s.CompanyId.Equals(myCompany))
		End Function

		Public Sub InsertStory(ByVal story As Story)
			story.CompanyId = myCompany
			story.Id = -1 ' database will replace with next auto-increment value
			If (story.EntityState <> EntityState.Detached) Then
				Me.ObjectContext.ObjectStateManager.ChangeObjectState(story, EntityState.Added)
			Else
				Me.ObjectContext.Stories.AddObject(story)
			End If
		End Sub

		Public Sub UpdateStory(ByVal currentStory As Story)
			' TODO: ensure user only edits authorized stories
            Me.ObjectContext.Stories.AttachAsModified(currentStory,
                                                      Me.ChangeSet.GetOriginal(currentStory))
		End Sub

		Public Sub DeleteStory(ByVal story As Story)
			' TODO: ensure user only deletes authorized stories
			If (story.EntityState = EntityState.Detached) Then
				Me.ObjectContext.Stories.Attach(story)
			End If
			Me.ObjectContext.Stories.DeleteObject(story)
		End Sub
	End Class
End Namespace


