﻿Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports CSSCustomerEdit.LoginUI

Namespace CSSCustomerEdit

	''' <summary>
	''' <see cref="UserControl"/> class providing the main UI for the application.
	''' </summary>
	Partial Public Class MainPage
		Inherits UserControl
		''' <summary>
		''' Creates a new <see cref="MainPage"/> instance.
		''' </summary>
		Public Sub New()
			InitializeComponent()
			Me.loginContainer.Child = New LoginStatus()
		End Sub

		''' <summary>
		''' After the Frame navigates, ensure the <see cref="HyperlinkButton"/> representing the current page is selected
		''' </summary>
		Private Sub ContentFrame_Navigated(ByVal sender As Object, ByVal e As NavigationEventArgs)
            For Each child In LinksStackPanel.Children
                Dim hb = TryCast(child, HyperlinkButton)
                If hb IsNot Nothing AndAlso hb.NavigateUri IsNot Nothing Then
                    If hb.NavigateUri.ToString().Equals(e.Uri.ToString()) Then
                        VisualStateManager.GoToState(hb, "ActiveLink", True)
                    Else
                        VisualStateManager.GoToState(hb, "InactiveLink", True)
                    End If
                End If
            Next child
		End Sub

		''' <summary>
		''' If an error occurs during navigation, show an error window
		''' </summary>
		Private Sub ContentFrame_NavigationFailed(ByVal sender As Object, ByVal e As NavigationFailedEventArgs)
			e.Handled = True
			ErrorWindow.CreateNew(e.Exception)
		End Sub
	End Class
End Namespace